---
stages:
  - site-build
  - image-build
  - deploy

jekyll:
  stage: site-build
  rules:
    - if: '$CI_COMMIT_TAG !~ /v[\d+]\.[\d+]\.[\d+].*/'
  image: ruby:2.7
  script:
    - cd jekyll
    - bundle install
    - bundle exec jekyll build
  artifacts:
    paths:
      - jekyll/_site
      
kaniko:
  stage: image-build
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
    
helm-to-eks-staging:
  stage: deploy
  rules:
    - if: '$CI_COMMIT_TAG =~ /v[\d+]\.[\d+]\.[\d+]-rc.*/'
  environment: staging
  tags:
    - exalt4git2kube
  image: alpine/helm
  script:
    - helm upgrade --install --wait staging chart/ --set image.tag=$CI_COMMIT_SHORT_SHA --namespace mar  --values chart/staging.yaml

helm-to-eks-prod:
  stage: deploy
  rules:
    - if: '$CI_COMMIT_TAG =~ /v[\d+]\.[\d+]\.[\d+]$/'
  environment: production
  tags:
    - exalt4git2kube
  image: alpine/helm
  script:
    - helm upgrade --install --wait prod chart/ --set image.tag=$CI_COMMIT_SHORT_SHA --namespace mar --values chart/prod.yaml
...
